Index: uspace/srv/hid/input/stroke.c
===================================================================
--- uspace/srv/hid/input/stroke.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/input/stroke.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2011 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -47,4 +47,5 @@
 /** Correspondence between modifers and the modifier keycodes. */
 static unsigned int mods_keys[][2] = {
+	{ KM_LALT, KC_LALT },
 	{ KM_LSHIFT, KC_LSHIFT },
 	{ KM_LCTRL, KC_LCTRL },
Index: uspace/srv/hid/isdv4_tablet/main.c
===================================================================
--- uspace/srv/hid/isdv4_tablet/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/isdv4_tablet/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2012 Martin Sucha
  * All rights reserved.
@@ -184,4 +185,5 @@
 	serial_t *serial;
 	char *serial_port_name = NULL;
+	loc_srv_t *srv;
 
 	int arg = 1;
@@ -315,5 +317,5 @@
 
 	async_set_fallback_port_handler(mouse_connection, NULL);
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register driver.\n", NAME);
@@ -329,6 +331,7 @@
 	}
 
-	rc = loc_service_register(service_name, &service_id);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, service_name, &service_id);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		printf(NAME ": Unable to register service %s.\n", service_name);
 		return rc;
@@ -340,5 +343,5 @@
 		printf(NAME ": Unable to get mouse category id.\n");
 	} else {
-		rc = loc_service_add_to_cat(service_id, mouse_category);
+		rc = loc_service_add_to_cat(srv, service_id, mouse_category);
 		if (rc != EOK) {
 			printf(NAME ": Unable to add device to mouse category.\n");
Index: uspace/srv/hid/isdv4_tablet/meson.build
===================================================================
--- uspace/srv/hid/isdv4_tablet/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/isdv4_tablet/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,4 +27,4 @@
 #
 
-deps = [ 'drv' ]
+deps = [ 'drv', 'input' ]
 src = files('main.c', 'isdv4.c')
Index: uspace/srv/hid/output/meson.build
===================================================================
--- uspace/srv/hid/output/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,5 +28,5 @@
 #
 
-deps = [ 'codepage', 'drv', 'fbfont', 'pixconv', 'ddev' ]
+deps = [ 'codepage', 'console', 'drv', 'fbfont', 'pixconv', 'ddev', 'output' ]
 src = files(
 	'ctl/serial.c',
Index: uspace/srv/hid/output/output.c
===================================================================
--- uspace/srv/hid/output/output.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/output.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -44,7 +45,4 @@
 #include "output.h"
 
-#define MAX_COLS  128
-#define MAX_ROWS  128
-
 typedef struct {
 	link_t link;
@@ -115,10 +113,18 @@
 static void srv_get_dimensions(ipc_call_t *icall)
 {
-	sysarg_t cols = MAX_COLS;
-	sysarg_t rows = MAX_ROWS;
-
-	list_foreach(outdevs, link, outdev_t, dev) {
-		cols = min(cols, dev->cols);
-		rows = min(rows, dev->rows);
+	sysarg_t cols = 0;
+	sysarg_t rows = 0;
+	bool first;
+
+	first = true;
+	list_foreach(outdevs, link, outdev_t, dev) {
+		if (first) {
+			cols = dev->cols;
+			rows = dev->rows;
+			first = false;
+		} else {
+			cols = min(cols, dev->cols);
+			rows = min(rows, dev->rows);
+		}
 	}
 
@@ -463,4 +469,6 @@
 int main(int argc, char *argv[])
 {
+	loc_srv_t *srv;
+
 	if (argc < 2) {
 		usage(argv[0]);
@@ -472,5 +480,5 @@
 	/* Register server */
 	async_set_fallback_port_handler(client_connection, NULL);
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register driver\n", NAME);
@@ -479,6 +487,8 @@
 
 	service_id_t service_id;
-	rc = loc_service_register(argv[1], &service_id);
+	rc = loc_service_register(srv, argv[1], &service_id);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
+
 		printf("%s: Unable to register service %s\n", NAME, argv[1]);
 		return rc;
Index: uspace/srv/hid/output/port/ega.c
===================================================================
--- uspace/srv/hid/output/port/ega.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/port/ega.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2011 Martin Decky
  * All rights reserved.
@@ -90,6 +90,11 @@
 		break;
 	case CHAR_ATTR_RGB:
-		attr = (attrs.val.rgb.bgcolor < attrs.val.rgb.fgcolor) ?
-		    ega.style_inverted : ega.style_normal;
+		attr =
+		    ((RED(attrs.val.rgb.fgcolor) >= 0x80) ? 0x40 : 0) |
+		    ((GREEN(attrs.val.rgb.fgcolor) >= 0x80) ? 0x20 : 0) |
+		    ((BLUE(attrs.val.rgb.fgcolor) >= 0x80) ? 0x10 : 0) |
+		    ((RED(attrs.val.rgb.bgcolor) >= 0x80) ? 0x04 : 0) |
+		    ((GREEN(attrs.val.rgb.bgcolor) >= 0x80) ? 0x02 : 0) |
+		    ((BLUE(attrs.val.rgb.bgcolor) >= 0x80) ? 0x01 : 0);
 		break;
 	}
Index: uspace/srv/hid/output/proto/vt100.c
===================================================================
--- uspace/srv/hid/output/proto/vt100.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/output/proto/vt100.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -41,5 +41,14 @@
 #include "vt100.h"
 
-#define MAX_CONTROL  20
+/** Buffer size when creating actual VT100 commands.
+ *
+ * This is absurdly large but since we accept numbers via sysarg_t,
+ * we make it big enough for the largest value to be on the safe side
+ * (and to silence compiler too).
+ *
+ * TODO: find out if VT100 has some hard limits or perhaps simply cut-out
+ * values larger than 16 bits or something.
+ */
+#define MAX_CONTROL 64
 
 typedef enum {
Index: uspace/srv/hid/remcons/meson.build
===================================================================
--- uspace/srv/hid/remcons/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/remcons/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -28,4 +28,4 @@
 #
 
-deps = [ 'inet' ]
+deps = [ 'inet', 'console' ]
 src = files('remcons.c', 'user.c')
Index: uspace/srv/hid/remcons/remcons.c
===================================================================
--- uspace/srv/hid/remcons/remcons.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/remcons/remcons.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,3 +1,4 @@
 /*
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2012 Vojtech Horky
  * All rights reserved.
@@ -110,4 +111,6 @@
 };
 
+static loc_srv_t *remcons_srv;
+
 static telnet_user_t *srv_to_user(con_srv_t *srv)
 {
@@ -301,5 +304,6 @@
 	telnet_user_add(user);
 
-	errno_t rc = loc_service_register(user->service_name, &user->service_id);
+	errno_t rc = loc_service_register(remcons_srv, user->service_name,
+	    &user->service_id);
 	if (rc != EOK) {
 		telnet_user_error(user, "Unable to register %s with loc: %s.",
@@ -332,5 +336,5 @@
 	fibril_mutex_unlock(&user->guard);
 
-	rc = loc_service_unregister(user->service_id);
+	rc = loc_service_unregister(remcons_srv, user->service_id);
 	if (rc != EOK) {
 		telnet_user_error(user,
@@ -351,5 +355,5 @@
 
 	async_set_fallback_port_handler(client_connection, NULL);
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &remcons_srv);
 	if (rc != EOK) {
 		fprintf(stderr, "%s: Unable to register server\n", NAME);
Index: uspace/srv/hid/rfb/main.c
===================================================================
--- uspace/srv/hid/rfb/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/rfb/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2013 Martin Sucha
  * All rights reserved.
@@ -443,4 +443,5 @@
 {
 	rfb_t rfb;
+	loc_srv_t *srv;
 
 	log_init(NAME);
@@ -482,5 +483,5 @@
 	async_set_fallback_port_handler(client_connection, &rfb);
 
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register server.\n", NAME);
@@ -497,5 +498,5 @@
 	service_id_t service_id;
 
-	rc = loc_service_register(service_name, &service_id);
+	rc = loc_service_register(srv, service_name, &service_id);
 	if (rc != EOK) {
 		printf(NAME ": Unable to register service %s.\n", service_name);
@@ -512,5 +513,5 @@
 	}
 
-	rc = loc_service_add_to_cat(service_id, ddev_cid);
+	rc = loc_service_add_to_cat(srv, service_id, ddev_cid);
 	if (rc != EOK) {
 		fprintf(stderr, NAME ": Unable to add service to display device category.\n");
Index: uspace/srv/hid/s3c24xx_ts/meson.build
===================================================================
--- uspace/srv/hid/s3c24xx_ts/meson.build	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/s3c24xx_ts/meson.build	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -27,3 +27,4 @@
 #
 
+deps = [ 'input' ]
 src = files('s3c24xx_ts.c')
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -39,5 +39,4 @@
 #include <ddi.h>
 #include <loc.h>
-#include <io/console.h>
 #include <vfs/vfs.h>
 #include <ipc/mouseev.h>
@@ -81,8 +80,10 @@
 int main(int argc, char *argv[])
 {
+	loc_srv_t *srv;
+
 	printf("%s: S3C24xx touchscreen driver\n", NAME);
 
 	async_set_fallback_port_handler(s3c24xx_ts_connection, NULL);
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register driver.\n", NAME);
@@ -91,12 +92,20 @@
 
 	ts = malloc(sizeof(s3c24xx_ts_t));
-	if (ts == NULL)
+	if (ts == NULL) {
+		loc_server_unregister(srv);
 		return -1;
-
-	if (s3c24xx_ts_init(ts) != EOK)
+	}
+
+	if (s3c24xx_ts_init(ts) != EOK) {
+		free(ts);
+		loc_server_unregister(srv);
 		return -1;
-
-	rc = loc_service_register(NAMESPACE "/mouse", &ts->service_id);
+	}
+
+	rc = loc_service_register(srv, NAMESPACE "/mouse", &ts->service_id);
 	if (rc != EOK) {
+		// XXX s3c24xx_ts_fini();
+		free(ts);
+		loc_server_unregister(srv);
 		printf(NAME ": Unable to register device %s.\n",
 		    NAMESPACE "/mouse");
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2010 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -80,8 +80,10 @@
 int main(int argc, char *argv[])
 {
+	loc_srv_t *srv;
+
 	printf("%s: S3C24xx on-chip UART driver\n", NAME);
 
 	async_set_fallback_port_handler(s3c24xx_uart_connection, uart);
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		printf("%s: Unable to register server.\n", NAME);
@@ -90,12 +92,20 @@
 
 	uart = malloc(sizeof(s3c24xx_uart_t));
-	if (uart == NULL)
-		return -1;
-
-	if (s3c24xx_uart_init(uart) != EOK)
-		return -1;
-
-	rc = loc_service_register(NAMESPACE "/" NAME, &uart->service_id);
+	if (uart == NULL) {
+		loc_server_unregister(srv);
+		return -1;
+	}
+
+	if (s3c24xx_uart_init(uart) != EOK) {
+		free(uart);
+		loc_server_unregister(srv);
+		return -1;
+	}
+
+	rc = loc_service_register(srv, NAMESPACE "/" NAME, &uart->service_id);
 	if (rc != EOK) {
+		// XXX s3c24xx_uart_fini(uart);
+		free(uart);
+		loc_server_unregister(srv);
 		printf(NAME ": Unable to register device %s.\n",
 		    NAMESPACE "/" NAME);
Index: uspace/srv/locsrv/locsrv.c
===================================================================
--- uspace/srv/locsrv/locsrv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/locsrv/locsrv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,5 +1,5 @@
 /*
+ * Copyright (c) 2024 Jiri Svoboda
  * Copyright (c) 2007 Josef Cejka
- * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -1354,4 +1354,7 @@
 	categ_dir_add_cat(&cdir, cat);
 
+	cat = category_new("tbarcfg-notif");
+	categ_dir_add_cat(&cdir, cat);
+
 	cat = category_new("test3");
 	categ_dir_add_cat(&cdir, cat);
@@ -1376,7 +1379,4 @@
 
 	cat = category_new("irc");
-	categ_dir_add_cat(&cdir, cat);
-
-	cat = category_new("renderer");
 	categ_dir_add_cat(&cdir, cat);
 
Index: uspace/srv/net/dhcp/dhcp.c
===================================================================
--- uspace/srv/net/dhcp/dhcp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/dhcp/dhcp.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -47,4 +47,5 @@
 #include <io/log.h>
 #include <loc.h>
+#include <rndgen.h>
 #include <stdio.h>
 #include <stdlib.h>
@@ -95,4 +96,6 @@
 	/** DNS server */
 	inet_addr_t dns_server;
+	/** Transaction ID */
+	uint32_t xid;
 } dhcp_offer_t;
 
@@ -114,4 +117,6 @@
 	/** Last received offer */
 	dhcp_offer_t offer;
+	/** Random number generator */
+	rndgen_t *rndgen;
 } dhcp_link_t;
 
@@ -154,4 +159,11 @@
 	dhcp_hdr_t *hdr = (dhcp_hdr_t *)msgbuf;
 	uint8_t *opt = msgbuf + sizeof(dhcp_hdr_t);
+	uint32_t xid;
+	errno_t rc;
+	size_t i;
+
+	rc = rndgen_uint32(dlink->rndgen, &xid);
+	if (rc != EOK)
+		return rc;
 
 	memset(msgbuf, 0, MAX_MSG_SIZE);
@@ -159,16 +171,25 @@
 	hdr->htype = 1; /* AHRD_ETHERNET */
 	hdr->hlen = ETH_ADDR_SIZE;
-	hdr->xid = host2uint32_t_be(42);
-	hdr->flags = flag_broadcast;
+	hdr->xid = host2uint32_t_be(xid);
+	hdr->flags = host2uint16_t_be(flag_broadcast);
 
 	eth_addr_encode(&dlink->link_info.mac_addr, hdr->chaddr);
 	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
 
-	opt[0] = opt_msg_type;
-	opt[1] = 1;
-	opt[2] = msg_dhcpdiscover;
-	opt[3] = opt_end;
-
-	return dhcp_send(&dlink->dt, msgbuf, sizeof(dhcp_hdr_t) + 4);
+	i = 0;
+
+	opt[i++] = opt_msg_type;
+	opt[i++] = 1;
+	opt[i++] = msg_dhcpdiscover;
+
+	opt[i++] = opt_param_req_list;
+	opt[i++] = 3;
+	opt[i++] = 1; /* subnet mask */
+	opt[i++] = 6; /* DNS server */
+	opt[i++] = 3; /* router */
+
+	opt[i++] = opt_end;
+
+	return dhcp_send(&dlink->dt, msgbuf, sizeof(dhcp_hdr_t) + i);
 }
 
@@ -183,7 +204,6 @@
 	hdr->htype = 1; /* AHRD_ETHERNET */
 	hdr->hlen = 6;
-	hdr->xid = host2uint32_t_be(42);
-	hdr->flags = flag_broadcast;
-	hdr->ciaddr = host2uint32_t_be(offer->oaddr.addr);
+	hdr->xid = host2uint32_t_be(offer->xid);
+	hdr->flags = host2uint16_t_be(flag_broadcast);
 	eth_addr_encode(&dlink->link_info.mac_addr, hdr->chaddr);
 	hdr->opt_magic = host2uint32_t_be(dhcp_opt_magic);
@@ -258,4 +278,5 @@
 
 	inet_naddr_set(yiaddr.addr, 0, &offer->oaddr);
+	offer->xid = uint32_t_be2host(hdr->xid);
 
 	msgb = (uint8_t *)msg;
@@ -457,4 +478,8 @@
 		return ENOMEM;
 
+	rc = rndgen_create(&dlink->rndgen);
+	if (rc != EOK)
+		goto error;
+
 	dlink->link_id = link_id;
 	dlink->timeout = fibril_timer_create(NULL);
@@ -494,4 +519,6 @@
 	return EOK;
 error:
+	if (dlink != NULL && dlink->rndgen != NULL)
+		rndgen_destroy(dlink->rndgen);
 	if (dlink != NULL && dlink->timeout != NULL)
 		fibril_timer_destroy(dlink->timeout);
Index: uspace/srv/net/dhcp/dhcp_std.h
===================================================================
--- uspace/srv/net/dhcp/dhcp_std.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/dhcp/dhcp_std.h	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2022 Jiri Svoboda
  * All rights reserved.
  *
@@ -87,5 +87,5 @@
 /** Values for dhcp_hdr_t.flags */
 enum dhcp_flags {
-	flag_broadcast = 0x80
+	flag_broadcast = 0x8000
 };
 
@@ -110,4 +110,6 @@
 	/** Server identifier */
 	opt_server_id = 54,
+	/** Parameter request list */
+	opt_param_req_list = 55,
 	/** End */
 	opt_end = 255
Index: uspace/srv/net/dhcp/main.c
===================================================================
--- uspace/srv/net/dhcp/main.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/dhcp/main.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -54,4 +54,5 @@
 static errno_t dhcp_init(void)
 {
+	loc_srv_t *srv;
 	errno_t rc;
 
@@ -68,5 +69,5 @@
 	async_set_fallback_port_handler(dhcp_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -75,6 +76,7 @@
 
 	service_id_t sid;
-	rc = loc_service_register(SERVICE_NAME_DHCP, &sid);
+	rc = loc_service_register(srv, SERVICE_NAME_DHCP, &sid);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
Index: uspace/srv/net/dnsrsrv/dnsrsrv.c
===================================================================
--- uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/dnsrsrv/dnsrsrv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -57,4 +57,5 @@
 static errno_t dnsr_init(void)
 {
+	loc_srv_t *srv;
 	errno_t rc;
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "dnsr_init()");
@@ -68,5 +69,5 @@
 	async_set_fallback_port_handler(dnsr_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -76,6 +77,7 @@
 
 	service_id_t sid;
-	rc = loc_service_register(SERVICE_NAME_DNSR, &sid);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, SERVICE_NAME_DNSR, &sid);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		transport_fini();
Index: uspace/srv/net/ethip/ethip.c
===================================================================
--- uspace/srv/net/ethip/ethip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/ethip/ethip.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -78,9 +78,11 @@
 };
 
+static loc_srv_t *ethip_srv;
+
 static errno_t ethip_init(void)
 {
 	async_set_fallback_port_handler(ethip_client_conn, NULL);
 
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &ethip_srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server.");
@@ -115,5 +117,5 @@
 	}
 
-	rc = loc_service_register(svc_name, &sid);
+	rc = loc_service_register(ethip_srv, svc_name, &sid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service %s.", svc_name);
@@ -129,5 +131,5 @@
 	}
 
-	rc = loc_service_add_to_cat(sid, iplink_cat);
+	rc = loc_service_add_to_cat(ethip_srv, sid, iplink_cat);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed adding %s to category.", svc_name);
Index: uspace/srv/net/inetsrv/inetsrv.c
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/inetsrv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2012 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -86,4 +86,6 @@
 static errno_t inet_init(void)
 {
+	loc_srv_t *srv;
+
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "inet_init()");
 
@@ -104,5 +106,5 @@
 		return rc;
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -111,6 +113,7 @@
 
 	service_id_t sid;
-	rc = loc_service_register(SERVICE_NAME_INET, &sid);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, SERVICE_NAME_INET, &sid);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
Index: uspace/srv/net/loopip/loopip.c
===================================================================
--- uspace/srv/net/loopip/loopip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/loopip/loopip.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -103,7 +103,9 @@
 static errno_t loopip_init(void)
 {
+	loc_srv_t *srv;
+
 	async_set_fallback_port_handler(loopip_client_conn, NULL);
 
-	errno_t rc = loc_server_register(NAME);
+	errno_t rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server.");
@@ -119,6 +121,7 @@
 	const char *svc_name = "net/loopback";
 	service_id_t sid;
-	rc = loc_service_register(svc_name, &sid);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, svc_name, &sid);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service %s.",
 		    svc_name);
@@ -129,10 +132,14 @@
 	rc = loc_category_get_id("iplink", &iplink_cat, IPC_FLAG_BLOCKING);
 	if (rc != EOK) {
+		loc_service_unregister(srv, sid);
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed resolving category 'iplink'.");
 		return rc;
 	}
 
-	rc = loc_service_add_to_cat(sid, iplink_cat);
-	if (rc != EOK) {
+	rc = loc_service_add_to_cat(srv, sid, iplink_cat);
+	if (rc != EOK) {
+		loc_service_unregister(srv, sid);
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed adding %s to category.",
 		    svc_name);
@@ -141,6 +148,9 @@
 
 	fid_t fid = fibril_create(loopip_recv_fibril, NULL);
-	if (fid == 0)
-		return ENOMEM;
+	if (fid == 0) {
+		loc_service_unregister(srv, sid);
+		loc_server_unregister(srv);
+		return ENOMEM;
+	}
 
 	fibril_add_ready(fid);
Index: uspace/srv/net/nconfsrv/nconfsrv.c
===================================================================
--- uspace/srv/net/nconfsrv/nconfsrv.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/nconfsrv/nconfsrv.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2013 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -59,4 +59,5 @@
 {
 	service_id_t sid;
+	loc_srv_t *srv;
 	errno_t rc;
 
@@ -79,5 +80,5 @@
 	async_set_fallback_port_handler(ncs_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server: %s.", str_error(rc));
@@ -85,6 +86,7 @@
 	}
 
-	rc = loc_service_register(SERVICE_NAME_NETCONF, &sid);
+	rc = loc_service_register(srv, SERVICE_NAME_NETCONF, &sid);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service: %s.", str_error(rc));
 		return EEXIST;
@@ -92,6 +94,9 @@
 
 	rc = ncs_link_discovery_start();
-	if (rc != EOK)
+	if (rc != EOK) {
+		loc_service_unregister(srv, sid);
+		loc_server_unregister(srv);
 		return EEXIST;
+	}
 
 	return EOK;
Index: uspace/srv/net/slip/slip.c
===================================================================
--- uspace/srv/net/slip/slip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/slip/slip.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * Copyright (c) 2013 Jakub Jermar
  * All rights reserved.
@@ -307,4 +307,5 @@
 	chardev_t *chardev_out = NULL;
 	fid_t fid;
+	loc_srv_t *srv;
 	errno_t rc;
 
@@ -314,5 +315,5 @@
 	async_set_fallback_port_handler(slip_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
@@ -323,4 +324,5 @@
 	rc = loc_service_get_id(svcstr, &svcid, 0);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR,
 		    "Failed getting ID for service %s", svcstr);
@@ -330,4 +332,5 @@
 	rc = loc_category_get_id(CAT_IPLINK, &iplinkcid, 0);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR,
 		    "Failed to get category ID for %s",
@@ -342,4 +345,5 @@
 	sess_out = loc_service_connect(svcid, INTERFACE_DDF, 0);
 	if (!sess_out) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR,
 		    "Failed to connect to service %s (ID=%d)",
@@ -350,4 +354,5 @@
 	rc = chardev_open(sess_out, &chardev_out);
 	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR,
 		    "Failed opening character device.");
@@ -373,5 +378,5 @@
 	}
 
-	rc = loc_service_register(linkstr, &linksid);
+	rc = loc_service_register(srv, linkstr, &linksid);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR,
@@ -381,6 +386,7 @@
 	}
 
-	rc = loc_service_add_to_cat(linksid, iplinkcid);
-	if (rc != EOK) {
+	rc = loc_service_add_to_cat(srv, linksid, iplinkcid);
+	if (rc != EOK) {
+		loc_service_unregister(srv, linksid);
 		log_msg(LOG_DEFAULT, LVL_ERROR,
 		    "Failed to add service %d (%s) to category %d (%s).",
@@ -401,4 +407,5 @@
 
 fail:
+	loc_server_unregister(srv);
 	chardev_close(chardev_out);
 	if (sess_out)
Index: uspace/srv/net/tcp/service.c
===================================================================
--- uspace/srv/net/tcp/service.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/tcp/service.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -1242,8 +1242,9 @@
 	errno_t rc;
 	service_id_t sid;
+	loc_srv_t *srv;
 
 	async_set_fallback_port_handler(tcp_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server.");
@@ -1251,6 +1252,7 @@
 	}
 
-	rc = loc_service_register(SERVICE_NAME_TCP, &sid);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, SERVICE_NAME_TCP, &sid);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service.");
 		return EIO;
Index: uspace/srv/net/udp/assoc.c
===================================================================
--- uspace/srv/net/udp/assoc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/udp/assoc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -243,5 +243,6 @@
  *
  * @param assoc		Association
- * @param remote	Remote endpoint or NULL not to override @a assoc
+ * @param remote	Remote endpoint or inet_addr_any/inet_port_any
+ *			not to override association's remote endpoint
  * @param msg		Message
  *
@@ -261,5 +262,6 @@
 	/* @a remote can be used to override the remote endpoint */
 	epp = assoc->ident;
-	if (remote != NULL)
+	if (!inet_addr_is_any(&remote->addr) &&
+	    remote->port != inet_port_any)
 		epp.remote = *remote;
 
Index: uspace/srv/net/udp/service.c
===================================================================
--- uspace/srv/net/udp/service.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/udp/service.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2015 Jiri Svoboda
+ * Copyright (c) 2023 Jiri Svoboda
  * All rights reserved.
  *
@@ -647,8 +647,9 @@
 	errno_t rc;
 	service_id_t sid;
+	loc_srv_t *srv;
 
 	async_set_fallback_port_handler(udp_client_conn, NULL);
 
-	rc = loc_server_register(NAME);
+	rc = loc_server_register(NAME, &srv);
 	if (rc != EOK) {
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering server.");
@@ -656,6 +657,7 @@
 	}
 
-	rc = loc_service_register(SERVICE_NAME_UDP, &sid);
-	if (rc != EOK) {
+	rc = loc_service_register(srv, SERVICE_NAME_UDP, &sid);
+	if (rc != EOK) {
+		loc_server_unregister(srv);
 		log_msg(LOG_DEFAULT, LVL_ERROR, "Failed registering service.");
 		return EIO;
Index: uspace/srv/net/udp/test/assoc.c
===================================================================
--- uspace/srv/net/udp/test/assoc.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/udp/test/assoc.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -250,11 +250,12 @@
 }
 
-/** Sending message with destination set in association and NULL destination
- * argument
+/** Sending message with destination set in association and inet_addr_any /
+ * inet_port_any destination argument
  */
-PCUT_TEST(send_assoc_null_dest)
-{
-	udp_assoc_t *assoc;
-	inet_ep2_t epp;
+PCUT_TEST(send_assoc_any_dest)
+{
+	udp_assoc_t *assoc;
+	inet_ep2_t epp;
+	inet_ep_t ep;
 	errno_t rc;
 	udp_msg_t *msg;
@@ -272,4 +273,6 @@
 	epp.local.port = 1;
 
+	inet_ep_init(&ep);
+
 	assoc = udp_assoc_new(&epp, &test_assoc_cb, NULL);
 	PCUT_ASSERT_NOT_NULL(assoc);
@@ -281,5 +284,5 @@
 	sent_msg = NULL;
 
-	rc = udp_assoc_send(assoc, NULL, msg);
+	rc = udp_assoc_send(assoc, &ep, msg);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 	PCUT_ASSERT_EQUALS(msg, sent_msg);
@@ -311,6 +314,4 @@
 
 	inet_ep2_init(&epp);
-	inet_addr(&epp.remote.addr, 127, 0, 0, 1);
-	epp.remote.port = 42;
 	inet_addr(&epp.local.addr, 127, 0, 0, 1);
 	epp.local.port = 1;
Index: uspace/srv/ns/service.c
===================================================================
--- uspace/srv/ns/service.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/ns/service.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -112,5 +112,5 @@
 
 /** Operations for service hash table. */
-static hash_table_ops_t service_hash_table_ops = {
+static const hash_table_ops_t service_hash_table_ops = {
 	.hash = service_hash,
 	.key_hash = service_key_hash,
@@ -121,5 +121,5 @@
 
 /** Operations for interface hash table. */
-static hash_table_ops_t iface_hash_table_ops = {
+static const hash_table_ops_t iface_hash_table_ops = {
 	.hash = iface_hash,
 	.key_hash = iface_key_hash,
Index: uspace/srv/ns/task.c
===================================================================
--- uspace/srv/ns/task.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/ns/task.c	(revision 6955907c088fa03863559fbf2f191e184d0109a3)
@@ -80,5 +80,5 @@
 
 /** Operations for task hash table. */
-static hash_table_ops_t task_hash_table_ops = {
+static const hash_table_ops_t task_hash_table_ops = {
 	.hash = task_hash,
 	.key_hash = task_key_hash,
@@ -131,5 +131,5 @@
 
 /** Operations for task hash table. */
-static hash_table_ops_t p2i_ops = {
+static const hash_table_ops_t p2i_ops = {
 	.hash = p2i_hash,
 	.key_hash = p2i_key_hash,
